//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_chat.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

typedef struct
{
   int iId;   //Radio command flag
   char radio_menu[8]; //Radio menu
   char radio_key[2]; //Key to press after choosing radio menu
   int radio_menu_msg; //Msg to wait when pressed radio menu
}
bot_radio_struct;

bot_radio_struct bot_radio_menu[] = {
                                       {RADIO_AFFIRMATIVE,  "radio3", "1", MSG_CS_RADIO3_SELECT}, //Affirmative
                                       {RADIO_COVERME,      "radio1", "5", MSG_CS_RADIO1_SELECT}, //Cover me
                                       {RADIO_FOLLOWME,     "radio1", "1", MSG_CS_RADIO1_SELECT},
                                       {RADIO_ONPOSITION,   "radio3", "5", MSG_CS_RADIO3_SELECT},
                                       {RADIO_ENEMYDOWN,    "radio3", "9", MSG_CS_RADIO3_SELECT},
                                       {RADIO_ENEMYSPOTTED, "radio3", "2", MSG_CS_RADIO3_SELECT},
                                       {RADIO_TAKINGFIRE,   "radio1", "6", MSG_CS_RADIO3_SELECT},
                                       //terminator
                                       {0,      "",   "" , 0}
                                    };

bool ApplyRadioCommand(player_t *pBot)
{
   bot_radio_struct *pSelect = NULL;
   pSelect = &bot_radio_menu[0];
   int select_index = 0;

   //Go through array
   while (pSelect[select_index].radio_menu_msg)
   {
      //If we have not This Radio command continue searching
      if (!(pBot->say_radio & pSelect[select_index].iId))
      {
         select_index++;
         continue;
      }
      //Execute Radio menu belongs to this command
      FakeClientCommand(pBot->pEdict, pSelect[select_index].radio_menu , NULL , NULL);
      //If menu haven't yet activated return and try later
      if (pBot->start_action != pSelect[select_index].radio_menu_msg)
         return FALSE;
      //Well we are current in menu so remove radio flag and menu
      pBot->say_radio = 0;//&= ~pSelect[select_index].iId;
      //Press key in radio menu for proper message
      FakeClientCommand(pBot->pEdict, "menuselect", pSelect[select_index].radio_key , NULL);
      pBot->start_action = MSG_CS_IDLE;
      //Don't say anything for next 3 seconds
      pBot->say_time = gpGlobals->time + 3;

      return TRUE; //Exit from function
   }

   return FALSE; //Nothing done?
}
